{# Note that small fractions work...inconsistently, in CK2.
Thus this file multiples the small fractions (which are correct)
by 100 accross the board, at least with regards to setting, changing, or
checking variables.  It seems to make it work consistently.
#}
IF = {
    limit = {
        OR = {
            had_province_flag = {flag = {{dc.evaluated_time_flag}} days=30}
            had_province_flag = {flag = {{dc.evaluated_cost_flag}} days=30}
            NOT = {
                has_province_flag = {{dc.evaluated_time_flag}}
                has_province_flag = {{dc.evaluated_cost_flag}}
            }
        }
    }
    {%for bp in dc.possible_time_breakpoints()%}
    clr_province_flag = {{bp.flag}}
    {% endfor %}
    {%for bp in dc.possible_cost_breakpoints()%}
    clr_province_flag = {{bp.flag}}
    {% endfor %}
    clr_province_flag = {{dc.evaluated_time_flag}}
    clr_province_flag = {{dc.evaluated_cost_flag}}
    set_variable ={ which="{{dc.time_variable}}" value=0.0 }
    set_variable ={ which="{{dc.cost_variable}}" value=0.0 }
    {# log = "FlagProvinceModifiers: Finished clearing in [This.GetName], [This.{{dc.cost_variable}}.GetName] is [This.{{dc.cost_variable}}.GetValue]"    #}
    {# check technology #}
    {% for tech in dc.technology() %}
    IF = {
        limit = { {{tech.name}}= {{tech.level}} {% if tech.level_not %} NOT = { {{tech.name}} = {{tech.level_not}} } {% endif %} }
        {# log = "FlagProvinceModifiers(Tech): Setting cost to {{tech.cost}} and time to {{tech.time}} in [This.GetName], [This.{{dc.cost_variable}}.GetName] is [This.{{dc.cost_variable}}.GetValue]"    #}
        {% if tech.time!=0.0 %}
        change_variable = {which="{{dc.time_variable}}" value={{tech.time*100}}} 
        {% endif %}
        {% if tech.cost!=0.0 %}
        change_variable = {which="{{dc.cost_variable}}" value={{tech.cost*100}}} 
        {% endif %}
        {% if dc.debug %}
        log = "AB accounted for level of {{tech.name}} in [This.GetName]." 
        {% endif %}}
    {% endfor %}
    {# check if construction is being assisted #}
    {% for action in dc.job_actions() %}
    ROOT = {
        any_voter = { limit = { at_location = PREVPREV has_job_action = {{action.name}}}
            trigger_switch = {
                on_trigger = {{action.attribute_name}}
                {% for attr,time, cost in action.effects %}
                {{attr}} = { PREVPREV = { {% if time!=0.0 %} change_variable = {which="{{dc.time_variable}}" value={{time*100}}} {% endif %}
                                          {% if cost!=0.0 %} change_variable = {which="{{dc.cost_variable}}" value={{cost*100}}} {% endif %}
                                          {% if dc.debug %} log = "AB accounted for job of [PREV.GetName] in [This.GetName].  Discount: {{time*100}}." {% endif %}}}
                {% endfor %}}}} 
    {% endfor %}
    {# check if any holding has a local modifier #}
    {# I can't use trigger_switch here because more than one might be true.#}
    {% if dc.event_modifiers() %}
    {% for mod in dc.event_modifiers() %}
    any_province_holding = {    
        limit={has_holding_modifier = {{mod.name}} }
        PREV = {
            {% if mod.time!=0.0 %}
            change_variable = {which="{{dc.time_variable}}" value={{mod.time*100}}}
            {% endif %}
            {% if mod.cost!=0.0 %}
            change_variable = {which="{{dc.cost_variable}}" value={{mod.cost*100}}}
            {% endif %}
            {% if dc.debug %}
            log = "AB accounted for holding modifier {{mod.name}} on [PREV.GetName] in [This.GetName]."
            {% endif %} }}
    {% endfor %}
    {# check if any local character has a modifier #}
    {% for mod in dc.event_modifiers() %}
    any_province_character = { 
        limit={has_character_modifier = {{mod.name}} same_realm = ROOT}    
        PREV = {
            {% if mod.time!=0.0 %}
            change_variable = {which="{{dc.time_variable}}" value={{mod.time*100}}}
            {% endif %}
            {% if mod.cost!=0.0 %}
            change_variable = {which="{{dc.cost_variable}}" value={{mod.cost*100}}}
            {% endif %}
            {% if dc.debug %}
            log = "AB accounted for character modifier {{mod.name}} on [PREV.GetName] in [This.GetName]."
            {% endif %} }}
    {% endfor %}
    {# check if the province itself has a modifer #}
    {% for mod in dc.event_modifiers() %}
    IF = {
        limit={has_province_modifier = {{mod.name}}}
        {% if mod.time!=0.0 %}
        change_variable = {which="{{dc.time_variable}}" value={{mod.time*100}}}
        {% endif %}
        {% if mod.cost!=0.0 %}
        change_variable = {which="{{dc.cost_variable}}" value={{mod.cost*100}}}
        {% endif %}
        {% if dc.debug %}
        log = "AB accounted for province modifier {{mod.name}} in [This.GetName]."
        {% endif %}}
    {% endfor %}
    {% endif %}
    {# check for global modifiers on root #}
    {% if dc.global_modifiers() or dc.permanent_artifacts() or dc.conditional_artifacts() or dc.bloodlines()%}
    ROOT = {
        {% for mod in dc.global_modifiers() %}
        IF = {
            limit={has_character_modifier = {{mod.name}}}
            PREV = {
                {% if mod.time!=0.0 %}
                change_variable = {which="{{dc.time_variable}}" value={{mod.time*100}}}
                {% endif %}
                {% if mod.cost!=0.0 %}
                change_variable = {which="{{dc.cost_variable}}" value={{mod.cost*100}}}
                {% endif %}
                {% if dc.debug %}
                log = "AB accounted for global modifier {{mod.name}} on [PREV.GetName] in [This.GetName]."
                {% endif %} }}
        {% endfor %}
        {#check for artifacts that affect build time held by root, if any exist #}    
        {% if dc.permanent_artifacts() or dc.conditional_artifacts() %}
        any_artifact = {         
            {% for artifact in dc.permanent_artifacts() %}
            IF = {
                limit={ artifact_type = {{artifact.name}}}
                PREVPREV = {
                    {% if artifact.time!=0.0 %}
                    change_variable = {which="{{dc.time_variable}}" value={{artifact.time*100}}}
                    {% endif %}
                    {% if artifact.cost!=0.0 %}
                    change_variable = {which="{{dc.cost_variable}}" value={{artifact.cost*100}}}
                    {% endif %}
                    {% if dc.debug %}
                    log = "AB accounted for permanently on artifact {{artifact.name}} owned by [PREV.GetName] in [This.GetName]."
                    {% endif %} }}
            {% endfor %}
            {% for artifact in dc.conditional_artifacts() %}
            IF = {
                limit={ 
                    artifact_type = {{artifact.name}}
                    {% if artifact.has_conditions %}
                    is_artifact_active = yes
                    {% endif %}
                    {% if artifact.equipable %}
                    is_artifact_equipped = yes
                    {% endif %}}
                PREVPREV = {
                    {% if artifact.time!=0.0 %}
                    change_variable = {which="{{dc.time_variable}}" value={{artifact.time*100}}}
                    {% endif %}
                    {% if artifact.cost!=0.0 %}
                    change_variable = {which="{{dc.cost_variable}}" value={{artifact.cost*100}}}
                    {% endif %}
                    {% if dc.debug %}
                    log = "AB accounted for equipped, active artifact {{artifact.name}} owned by [PREV.GetName] in [This.GetName]."
                    {% endif %} }}
            {% endfor %}    
        } 
        {% endif %}
        {#check for bloodlines that affect build time held by root, if any exist #}
        {% if dc.bloodlines() and dc.enable_bloodlines %}
        any_owned_bloodline = {
            {% for bloodline in dc.bloodlines() %}
            IF = {limit={bloodline_type = {{bloodline.name}} bloodline_is_active_for = ROOT}
                PREVPREV = {
                    {% if bloodline.time!=0.0 %}
                    change_variable = {which="{{dc.time_variable}}" value={{bloodline.time*100}}}
                    {% endif %}
                    {% if bloodline.cost!=0.0 %}
                    change_variable = {which="{{dc.cost_variable}}" value={{bloodline.cost*100}}}
                    {% endif %}
                    {% if dc.debug %}
                    log = "AB accounted for active bloodine {{bloodline.name}} of [PREVPREV.GetName] in [This.GetName]."
                    {% endif %} }
            }
            {% endfor %}
        }
        {% endif %}
    }
    {% endif %}
    {# set time flags #}
    {% for breakpoint in dc.possible_time_breakpoints() %}
    IF = { limit = {NOT = {has_province_flag={{dc.evaluated_time_flag}}}
                 check_variable={which="{{dc.time_variable}}" value={{breakpoint.value*100}}}}
            {# log = "FlagProvinceModifiers: Setting time flag to {{breakpoint.flag}} in [This.GetName], [This.{{dc.time_variable}}.GetName] is [This.{{dc.time_variable}}.GetValue]" #}
            set_province_flag={{dc.evaluated_time_flag}}
            set_province_flag={{breakpoint.flag}}
            {% if dc.debug %}
            log = "AB set time discount flag {{breakpoint.flag}} in [This.GetName]."
            {% endif %} 
    }
    {% endfor %}
    IF = { limit = {NOT = {has_province_flag={{dc.evaluated_time_flag}}}}
            {# log = "FlagProvinceModifiers: Setting time flag to {{dc.default_time_flag}} in [This.GetName], [This.{{dc.time_variable}}.GetName] is [This.{{dc.time_variable}}.GetValue]" #}
            set_province_flag={{dc.evaluated_time_flag}}
            set_province_flag={{dc.min_time_flag}}
            {% if dc.debug %}
            log = "AB set time discount flag {{dc.min_time_flag}} in [This.GetName]."
            {% endif %} 
    }    
    {# set cost flags #}
    {% for breakpoint in dc.possible_cost_breakpoints() %}
    IF = { limit = {NOT = {has_province_flag={{dc.evaluated_cost_flag}}}
                 check_variable={which="{{dc.cost_variable}}" value={{breakpoint.value*100}}}}
            {# log = "FlagProvinceModifiers: Setting cost flag to {{breakpoint.flag}} in [This.GetName], [This.{{dc.cost_variable}}.GetName] is [This.{{dc.cost_variable}}.GetValue]" #}
            set_province_flag={{dc.evaluated_cost_flag}}
            set_province_flag={{breakpoint.flag}}
            {% if dc.debug %}
            log = "AB set cost discount flag {{breakpoint.flag}} in [This.GetName]."
            {% endif %} 
    }
    {% endfor %}
    IF = { limit = {NOT = {has_province_flag={{dc.evaluated_cost_flag}}}}
            {# log = "FlagProvinceModifiers: Setting cost flag to {{dc.default_cost_flag}} in [This.GetName], [This.{{dc.cost_variable}}.GetName] is [This.{{dc.cost_variable}}.GetValue]" #}
            set_province_flag={{dc.evaluated_cost_flag}}
            set_province_flag={{dc.min_cost_flag}}
            {% if dc.debug %}
            log = "AB set cost discount flag {{dc.min_cost_flag}} in [This.GetName]."
            {% endif %} 
    }
}